"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = Form;
exports.FormContextConsumer = exports.FormContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _set = _interopRequireDefault(require("lodash/set"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const FormContext = _react.default.createContext({});

exports.FormContext = FormContext;

function Form({
  children,
  onValues,
  values,
  rules
}) {
  let [errors, setErrors] = (0, _react.useState)([]);
  let [valuesBlurred, setValuesBlurred] = (0, _react.useState)({});
  return _react.default.createElement(FormContext.Provider, {
    value: {
      rules: rules || {},
      values,
      errors,
      setErrors,
      valuesBlurred,
      setValuesBlurred,
      hasBlurred: name => {
        if (valuesBlurred[name]) return; //Store list of values that have been touched, so we can run validation on them now

        setValuesBlurred({ ...valuesBlurred,
          [name]: true
        });
      },
      updateValue: (name, value) => {
        let newValues = { ...values
        };
        (0, _set.default)(newValues, name, value);
        onValues(newValues);
      }
    }
  }, children);
}

const FormContextConsumer = FormContext.Consumer;
exports.FormContextConsumer = FormContextConsumer;