"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _validate = _interopRequireDefault(require("./validate"));

var _form = require("./form");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const useSubmit = () => {
  const {
    rules,
    values,
    errors,
    setErrors,
    setValuesBlurred
  } = _react.default.useContext(_form.FormContext);

  const handleSubmit = callback => {
    let errors = (0, _validate.default)({
      values,
      rules,
      setErrors
    });
    if (!errors.length) return callback(values); // if there are errors, mark all values as blurred,
    // so validation runs on change after hitting submit

    setValuesBlurred(Object.keys(rules).reduce((acc, name) => ({ ...acc,
      [name]: true
    }), {}));
  };

  return {
    values,
    handleSubmit,
    canSubmit: !errors.length
  };
};

var _default = useSubmit;
exports.default = _default;