import React, { Dispatch, SetStateAction, ReactNode } from 'react';
import { RuleFn } from './rules';
export declare type ValuesBlurred = {
    [key: string]: boolean;
};
export declare type Error = {
    name: string;
    message: string;
};
declare type Context = {
    rules: any;
    values: any;
    errors: Error[];
    valuesBlurred: ValuesBlurred;
    hasBlurred: (name: string) => any;
    setErrors: Dispatch<SetStateAction<Error[]>>;
    updateValue: (name: string, value: string) => any;
    setValuesBlurred: Dispatch<SetStateAction<ValuesBlurred>>;
};
declare const FormContext: React.Context<Context>;
export declare type FormProps<Values> = {
    values: Values;
    children: ReactNode;
    onValues: Dispatch<SetStateAction<any>>;
    rules?: {
        [key in keyof Partial<Values>]: RuleFn[];
    };
};
declare function Form<Values>({ children, onValues, values, rules, }: FormProps<Values>): JSX.Element;
declare const FormContextConsumer: React.Consumer<Context>;
export { FormContext, Form, FormContextConsumer };
